#include <boost/mpl/vector_c.hpp>
#include <boost/mpl/or.hpp>
#include <boost/mpl/and.hpp>
#include <boost/mpl/for_each.hpp>
#include <boost/mpl/range_c.hpp>
#include <boost/mpl/transform.hpp>
#include <boost/lambda/bind.hpp>
#include <boost/mpl/size.hpp>


template<class CDB >
struct CDer;


template<class CDB, class CDB1>
struct CMyOperation
{	const CDer<CDB> &m_r0;
	const CDer<CDB1> &m_r1;
	typename CDer<boost::mpl::transform<CDB, CDB1, boost::mpl::or_<bool, bool> > > CDerOr;
	CDerOr &m_rT;
	unsigned int m_iPos;
	CMyOperation(const CThis &_r0, const CDer<CDB1> &_r1, CDerOr &_rT)
	    :m_r0(_r0),
	     m_r1(_r1),
	     m_rT(_rT),
	     m_iPos(0)
	{
	}
	void operator()(const std::pair<bool, bool> &_r)
	{	++m_iPos;
	}
	
};


struct CCreatePair
{	std::pair<bool, bool> operator()(const bool _b0, const bool _b1) const
	{	return std::pair<bool, bool>(_b0, _b1);
	}
};


template<class CDB >
struct CDer
{
	public:
	typedef CDer<CDB > CThis;
	inline CDer(void)
	{
	}
	template<class CDB1>
	friend inline CMyOperation<CDB, CDB1>::CDerOr myOperation(const CThis &_r0, const CDer<CDB1> &_r1)
	{	CMyOperation<CDB, CDB1>::CDerOr sRet;
		typedef boost::mpl::transform<CDB, CDB1, CCreatePair> CMerged;
		CMyOperation<CDB, CDB1> sOp(_r0, _r1, sRet);
		boost::mpl::for_each<CMerged>(sOp);
		return sRet;
	}
};

int main(int argc, char **argv)
{
	CDer<boost::mpl::vector_c<bool, true, true>::type > sDer0;
	CDer<boost::mpl::vector_c<bool, false, true>::type > sDer1;

	myOperation(sDer0, sDer1);
	return 0;
}